;;-------------------------------------------------------
;; UMTB GAME - LISP (Lost In Stupid Parentheses) version
;; Jan Matuska, matuska@kn.vutbr.cz
;; VUT-ID: 14689
;; Group:  5O/48
;; Text file: je nutne ve fci text nastavit spravny adr.
;;-------------------------------------------------------




; funkce realizujici newline
(defun nl ()
  (format t "~%")
)

; vypise text na konzoli
(defun wr (text)
  (format t "~{~a~}" text)
)

; precte hlasku s indexem a z souboru textu
(defun text (a)
  (setq f (open "d:/text.txt"))
  (do ((x (read f nil f) (read f nil f)))
    ((eq x f))
      (cond
        ( (eq (first x) a) (nl) (wr (rest x)) )
      )
  )
)


; vstup prikazu... reseno ve smycce, dokud neni zadan spravny prikaz
(defun input ()
 (nl) (nl)
 (wr '("Prikazy: [s]ever, [j]ih, [z]apad, [v]vychod, vz[i]t, [h]elp, [k]onec"))
 (nl) 
 (loop
   (setq counter (+ counter 1))
   (wr '("Zadej povel: "))  
   (setq c (read))
   (case c
      ('s  (wr '("Jdes na sever"))  (text 'lines)(return-from input 's) )
      ('j  (wr '("Jdes na jih"))    (text 'lines)(return-from input 'j) )
      ('z  (wr '("Jdes na zapad"))  (text 'lines)(return-from input 'z) )
      ('v  (wr '("Jdes na vychod")) (text 'lines)(return-from input 'v) )
      ('i  (wr '("Beres"))          (text 'lines)(return-from input 'i) )
      ('k  (wr '("Adios amigo.."))  (text 'lines)(return-from input 'k) )
      ('h  (text 'help) (read) (return-from input) )
    )
    (wr '("Takovy prikaz zde neni."))  (nl) (nl)
 )
)



; -- obsluha mistnosti 1 - pocitacova ucebna A4/715 --
(defun room1 ()
  (cond
    ( (eq plny-brisko 'ano) (text 'room-1-najezen) )
    ( (text 'room-1) )
  )
  (text 'room-1-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 's) (setq room 2) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 2 - chodba na A4/7p. --
(defun room2 ()
  (text 'room-2)
  (text 'room-2-cmd)
  (setq cmd (input))  
  (cond
    ( (eq cmd 'j) (setq room 1) )
    ( (eq cmd 'z) (setq room 3) )
    ( (eq cmd 'v) (setq room 6) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 3 - u vytahu na A4/7p. --
(defun room3 ()
  (text 'room-3)
  (text 'room-3-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 's) (setq room 31) )
    ( (eq cmd 'z) (setq room 4) )
    ( (eq cmd 'v) (setq room 2) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 4 - u vchodu do UMTB --
(defun room4 ()
  (text 'room-4)
  (text 'room-4-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 's) (setq room 5) )
    ( (eq cmd 'v) (setq room 3) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 5 - uvnitr UMTB -- 
(defun room5 ()
  (text 'room-5)
  (cond
    ( (and (eq mam-bombu 'ano) (eq armed 'ne) ) (text 'room-5-bomb) (setq armed 'ano) )
    ( (eq armed 'ano)  (text 'room-5-armed) )
  )  
  (text 'room-5-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'j) (setq room 4) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 6 - u cerveneho vytahu --
(defun room6 ()
  (text 'room-6)
  (text 'room-6-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'z) (setq room 2) )
    ( (eq cmd 'v) (setq room 61) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 61 - u dveri --
(defun room61 ()
  (text 'room-61)
  (text 'room-61-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'z) (setq room 6) )
    ( (eq cmd 'v) (setq room 7) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 7 - kumbal uklizecky --
(defun room7 ()
  (cond
    ( (eq mam-klic 'ne)  (text 'room-7-nemam-klic) (text 'lines) (setq room 61) (return-from room7) )
  ) 
  (text 'room-7)
  (cond
    ( (eq mam-bombu 'ne)  (text 'room-7-bomb) (text 'room-7-cmd) )
    ( (text 'room-7-cmd2) )
  ) 
 (setq cmd (input))
  (cond
    ( (eq cmd 'z) (setq room 61) )
    ( (and (eq cmd 'i) (eq mam-bombu 'ne) ) (setq mam-bombu 'ano) (text 'room-7-beres-bombu) )
    ( (and (eq cmd 'i) (eq mam-bombu 'ano) ) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)

; -- obsluha mistnosti 31 - ve vytahu cestou dolu --
(defun room31 ()
  (text 'room-31)
  (text 'room-31-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'j) (setq room 8) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 8 - dole u vytahu --
(defun room8 ()
  (text 'room-8)
  (text 'room-8-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'j) (setq room 13) )
    ( (eq cmd 'z) (setq room 9) )
    ( (eq cmd 's) (setq room 32) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)

; -- obsluha mistnosti 32 - ve vytahu cestou nahoru --
(defun room32 ()
  (text 'room-32)
  (text 'room-32-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'j) (setq room 3) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 9 - u male vratnice --
(defun room9 ()
  (text 'room-9)
  (text 'room-9-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'v) (setq room 8) )
    ( (eq cmd 'z) (setq room 10) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 10 - u prednaskovek--
(defun room10 ()
  (text 'room-10)
  (text 'room-10-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'v) (setq room 9) )
    ( (eq cmd 'z) (setq room 11) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)

; -- obsluha mistnosti 11 - u prednaskovek--
(defun room11 ()
  (text 'room-11)
  (text 'room-11-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 'v) (setq room 10) )
    ( (eq cmd 'z) (setq room 12) )
    ( (eq cmd 'j) (setq room 14) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 12 - menza --
(defun room12 ()
  (cond
    ( (eq plny-brisko 'ne)  (text 'room-12)  )
    ( (text 'room-12-repete) )
  ) 
  (cond
    ( (eq mam-klic 'ne)  (text 'room-12-vidis-klic)  )
  ) 
  (text 'room-12-cmd)
  (setq plny-brisko 'ano)
  (setq cmd (input))
  (cond
    ( (eq cmd 'v) (setq room 11) )
    ( (and (eq cmd 'i) (eq mam-klic 'ne) ) (setq mam-klic 'ano) (text 'room-12-beres-klic) (setq room 11) )
    ( (and (eq cmd 'i) (eq mam-klic 'ano) ) (text 'zde-nic-neni) )    
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 13 - venku u smradu --
(defun room13 ()
  (cond
    ( (eq armed 'ano) (setq room 99) (return-from room13) )
  )   
  (text 'room-13)
  (text 'room-13-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 's) (setq room 8) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 14 - venku u smradu --
(defun room14 ()
  (cond
    ( (eq armed 'ano) (setq room 99) (return-from room14) )
  )   
  (text 'room-14)
  (text 'room-14-cmd)
  (setq cmd (input))
  (cond
    ( (eq cmd 's) (setq room 11) )
    ( (eq cmd 'i) (text 'zde-nic-neni) )
    ( (eq cmd 'k) (setq exit-flag 'ano) )
    ( (text 'drzkoryje) )
  )
  (text 'lines)
)


; -- obsluha mistnosti 99 - final
(defun room99 ()
  (text 'room-99)
  (format t "~%             Pocet kroku hry ~D znamena, ze tve IQ je ~D~% " counter (- 170 counter))
  (setq exit-flag 'ano)
)



; The story begins here ....
(defun main ()
  (text 'umtb-game)
  (read)
  (setq room 1)
  (setq counter     0)
  (setq exit-flag   'ne)
  (setq plny-brisko 'ne)
  (setq mam-klic    'ne)
  (setq mam-bombu   'ne)
  (setq armed       'ne)  
  (loop
    ( when (eq exit-flag 'ano) (return) )
    ( when (eq room 1) (room1) )
    ( when (eq room 2) (room2) )
    ( when (eq room 3) (room3) )
    ( when (eq room 31) (room31) )     
    ( when (eq room 32) (room32) )      
    ( when (eq room 4) (room4) ) 
    ( when (eq room 5) (room5) )
    ( when (eq room 6) (room6) )
    ( when (eq room 61) (room61) )     
    ( when (eq room 7) (room7) )
    ( when (eq room 8) (room8) )
    ( when (eq room 9) (room9) )
    ( when (eq room 10) (room10) )
    ( when (eq room 11) (room11) )
    ( when (eq room 12) (room12) )
    ( when (eq room 13) (room13) )
    ( when (eq room 14) (room14) )
    ( when (eq room 99) (room99) )         
  )
)








(main)
